#ifndef LINKEDLIST_H
#define LINKEDLIST_H

typedef struct llist_node LNode;
struct llist_node {
	void *data;
	LNode *next;
};

typedef void (*LlistDestroyF)(void *);

LNode *llist_new_base();
void llist_destroy(LNode *base);
void llist_destroy_with_function(LNode *base, LlistDestroyF function);
LNode *llist_prepend_copy(LNode *base, const void *data, size_t data_size);

#endif /* LINKEDLIST_H */
