#include <stdio.h>
#include "dumputil.h"

void print_byte_seq(const void *byte, unsigned int byte_num, int mode)
{
    const unsigned char *b = byte;
    unsigned int i;

    if (b == NULL)
        return;

    for (i = 0; i < byte_num; i++) {
        if (mode == NUMBERING_MODE && (i % 16) == 0)
            printf("%10d byte : ", i);
        printf("%02X", b[i]);
        if ((i % 16) == 15 || i == (byte_num - 1)) {
            putchar('\n');
        } else if ((i % 8) == 7) {
            putchar(' ');
            putchar(' ');
        } else {
            putchar(' ');
        }
    }
}

void press_any_key()
{
    fputs("\nPress any key\n", stderr);
    getchar();
}
